import 'package:clean_android_design/src/services/models_interfaces.dart';
import 'package:cloud_firestore/cloud_firestore.dart';

abstract class DatabaseReadOnlyCollectionServiceInterface<
    T extends ReadOnlyDatabaseItem<T>> {
  Stream<List<T>> get stream;

  Stream<T> documentStream(String id, {bool considerSubItems = false});
  Future<T> document(String id,
      {Source source = Source.serverAndCache, bool considerSubItems = false});
}

abstract class DatabaseCollectionServiceInterface<
        T extends UpdateableDatabaseItem<T>>
    extends DatabaseReadOnlyCollectionServiceInterface<T> {
  Future update(T object,
      {List<String> onlyUpdateKeys, bool considerSubItems = false});
  Future<DocumentReference> add(T object, {bool considerSubItems = false});
}

abstract class DatabaseServiceInterface {
  DatabaseCollectionServiceInterface<T>
      collectionService<T extends UpdateableDatabaseItem<T>>(
          UpdateableDatabaseItem item);
}
